#include <Arduino.h>
#include <TM1637TinyDisplay.h>                  // Bibliothek für die 7- Segment Anzeige
 
#define echo 15                                 //Anschluss ECHO vom HC-SR04 wurde für PIN 15 festgelegt
#define trig 16                                 //Anschluss TRIG vom HC-SR04 wurde für PIN 16 festgelegt
 
int distanz1 = 0;                             //Entfernung als globale Variable anlegen 



//Funktion zur Messung der Entfernung über den Ultraschallsensor HC-SR04 (mit Echo und Trigger), Ausgabe in mm
int EntfernungsMessung1 (){

  long distanz1 = 0;                                                                      //Deklaration der Variablen "distanz1"
  long zeitx1 = 0;                                                                        //Deklaration der Variablen "zeitx"
 
  digitalWrite (trig, LOW);                                                               //setzt den Zustand von trig auf LOW
  delayMicroseconds(3);                                                                   //setzt eine Pause/Unterbrechung von 3 Mikrosekunden
  noInterrupts();                                                                         //verhindert eine Unterbrechung des Vorgangs
  digitalWrite(trig, HIGH);                                                               //setzt den Zustand von trig auf HIGH
  delayMicroseconds(10);                                                                  //setzt eine Pause/Unterbrechung von 10 Mikrosekunden
  digitalWrite(trig, LOW);                                                                //setzt den Zustand von trig auf LOW
  zeitx1 = pulseIn(echo, HIGH);
  interrupts();                                                                           //lässt Vorgangsunterbrechungen erneut zu
  
  zeitx1 = (((zeitx1 * 344)/1000)/2);                                                     //vererrechnet den Wert der Zeit mit der Schallgeschwindigkeit nach der Raumtemperaur, 
                                                                                          //dem Faktor für die Kommastelle und halbiert diesen wegen der doppelten strecke (hin+zurück)
  distanz1 = zeitx1;
  Serial.print("distanz1  Wert01:");                                                      //Ausgabe des Wertetyps in den seriellen Monitor
  Serial.print(distanz1);                                                                 //Ausgabe des Wertes in den serieleln Monitor
  Serial.println("");
  delay (200);                                                                            //Verzögerung zur nächsten Messung
  return (distanz1);                                                                      //Ausgabe des Wertes für die Entfernung
}
void setup()
{
  pinMode(trig, OUTPUT);      //Legt den Eingangstyp des angegebenen PINs fest
  pinMode(echo, INPUT);       //Legt den Eingangstyp des angegebenen PINs fest
}
 
 
void loop()
{
  entfernung = getEntfernung();
}
